package com.adventurer_engine.common.entity.projectiles;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import abw;
import acf;
import aqz;
import asx;
import ata;
import atc;
import by;
import com.adventurer_engine.common.PlayerTools;
import com.adventurer_engine.common.gadgets.DamagePacket;
import com.adventurer_engine.common.items.blank.ranged_weapon.BasicAmmo;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import java.util.List;
import ls;
import nb;
import nc;
import nn;
import of;
import uf;
import un;

public abstract class EntityBulletGeneral extends nn implements un {
  private String hitSound = null;
  
  private int ticksInGround;
  
  private int xTile = -1;
  
  private int yTile = -1;
  
  private int zTile = -1;
  
  private boolean inGround;
  
  private int inTile;
  
  private boolean gravity = true;
  
  public void setNoeff(boolean noeff) {
    this.noeff = noeff;
  }
  
  public void setPenetrate(boolean penetrate) {
    this.penetrate = penetrate;
  }
  
  public void setIceDamage(double iceDamage) {
    this.iceDamage = iceDamage;
  }
  
  public boolean noeff = false;
  
  private boolean penetrate = false;
  
  private double iceDamage = 0.0D;
  
  private int inData;
  
  private int ticksInAir;
  
  private nn shootingEntity;
  
  public void setDamage(double damage) {
    this.damage = damage;
  }
  
  private double damage = 2.0D;
  
  private BasicAmmo ammo;
  
  private DamagePacket dmgPack;
  
  private float knockbackStrength = 0.0F;
  
  private double maxRange;
  
  public double beginX;
  
  public double beginZ;
  
  private static final float sizeX = 0.4F;
  
  private static final float sizeY = 0.4F;
  
  public EntityBulletGeneral(abw world) {
    super(world);
    this.l = 10.0D;
    a(0.4F, 0.4F);
  }
  
  public EntityBulletGeneral(abw world, double x, double y, double z) {
    super(world);
    this.l = 10.0D;
    a(0.4F, 0.4F);
    b(x, y, z);
    this.N = 0.0F;
  }
  
  public EntityBulletGeneral(abw par1World, of par2EntityLivingBase, float speed, float accuracy) {
    super(par1World);
    this.l = 10.0D;
    this.shootingEntity = (nn)par2EntityLivingBase;
    a(0.4F, 0.4F);
    b(par2EntityLivingBase.u, par2EntityLivingBase.v + par2EntityLivingBase.f(), par2EntityLivingBase.w, par2EntityLivingBase.A, par2EntityLivingBase.B);
    this.u -= (ls.b(this.A / 180.0F * 3.1415927F) * 0.16F);
    if (this.gravity)
      this.v -= 0.10000000149011612D; 
    this.w -= (ls.a(this.A / 180.0F * 3.1415927F) * 0.16F);
    b(this.u, this.v, this.w);
    this.beginX = this.u;
    this.beginZ = this.w;
    this.N = 0.0F;
    this.x = (-ls.a(this.A / 180.0F * 3.1415927F) * ls.b(this.B / 180.0F * 3.1415927F));
    this.z = (ls.b(this.A / 180.0F * 3.1415927F) * ls.b(this.B / 180.0F * 3.1415927F));
    this.y = -ls.a(this.B / 180.0F * 3.1415927F);
    if (accuracy < 1.0D) {
      double[] nv = PlayerTools.disturbVector(this.x, this.y, this.z, accuracy);
      this.x = nv[0];
      this.y = nv[1];
      this.z = nv[2];
    } 
    c(this.x, this.y, this.z, speed * 1.5F, 1.0F);
  }
  
  public void l_() {
    super.l_();
    if (this.maxRange != 0.0D) {
      double deltaX = this.u - this.beginX, deltaZ = this.w - this.beginZ;
      if (deltaX * deltaX + deltaZ * deltaZ > this.maxRange)
        x(); 
    } 
    if (this.D == 0.0F && this.C == 0.0F) {
      float speed_vec_len = ls.a(this.x * this.x + this.z * this.z);
      this.C = this.A = (float)(Math.atan2(this.x, this.z) * 180.0D / Math.PI);
      this.D = this.B = (float)(Math.atan2(this.y, speed_vec_len) * 180.0D / Math.PI);
    } 
    int currentBlockID = this.q.a(this.xTile, this.yTile, this.zTile);
    if (currentBlockID > 0) {
      aqz.s[currentBlockID].a((acf)this.q, this.xTile, this.yTile, this.zTile);
      asx axisalignedbb = aqz.s[currentBlockID].b(this.q, this.xTile, this.yTile, this.zTile);
      if (axisalignedbb != null && axisalignedbb.a(this.q.V().a(this.u, this.v, this.w)))
        this.inGround = true; 
    } 
    if (this.inGround) {
      int currentBlockId = this.q.a(this.xTile, this.yTile, this.zTile);
      int currentBlockData = this.q.h(this.xTile, this.yTile, this.zTile);
      if (currentBlockId == this.inTile && currentBlockData == this.inData) {
        this.ticksInGround++;
        if (this.ticksInGround >= 10)
          x(); 
      } else {
        this.inGround = false;
        this.x *= (this.ab.nextFloat() * 0.2F);
        if (this.gravity)
          this.y *= (this.ab.nextFloat() * 0.2F); 
        this.z *= (this.ab.nextFloat() * 0.2F);
        this.ticksInGround = 0;
        this.ticksInAir = this.penetrate ? 5 : 0;
      } 
    } else {
      this.ticksInAir++;
      atc vec3 = this.q.V().a(this.u, this.v, this.w);
      atc vec31 = this.q.V().a(this.u + this.x, this.v + this.y, this.w + this.z);
      ata bullet = this.q.a(vec3, vec31, false, true);
      vec3 = this.q.V().a(this.u, this.v, this.w);
      vec31 = this.q.V().a(this.u + this.x, this.v + this.y, this.w + this.z);
      if (bullet != null)
        vec31 = this.q.V().a(bullet.f.c, bullet.f.d, bullet.f.e); 
      List<nn> aabbEntityList = this.q.b(this, this.E.a(this.x, this.y, this.z).b(0.2D, 0.2D, 0.2D));
      double lastDistance = 0.0D;
      nn wounded = null;
      for (nn tmp : aabbEntityList) {
        if (tmp.L() && (tmp != this.shootingEntity || this.ticksInAir >= 5)) {
          float f = 0.3F;
          asx aabb = tmp.E.b(f, f, f);
          ata position = aabb.a(vec3, vec31);
          if (position != null) {
            double distance = vec3.d(position.f);
            if (distance < lastDistance || lastDistance == 0.0D) {
              wounded = tmp;
              lastDistance = distance;
            } 
            continue;
          } 
          if (this.penetrate)
            wounded = (tmp instanceof uf) ? null : tmp; 
        } 
      } 
      if (wounded != null)
        bullet = new ata(wounded); 
      if (bullet != null && bullet.g instanceof uf) {
        uf entityplayer = (uf)bullet.g;
        if (entityplayer.bG.a || (this.shootingEntity instanceof uf && !((uf)this.shootingEntity).a(entityplayer)))
          bullet = null; 
      } 
      if (bullet != null)
        if (bullet.g != null) {
          nb dmg;
          if (this.shootingEntity == null) {
            dmg = nb.a(this, this);
          } else {
            dmg = nb.a(this, this.shootingEntity);
          } 
          if (af())
            bullet.g.d(5); 
          boolean flag = false;
          if (bullet.g instanceof of && this.shootingEntity != null)
            if (this.dmgPack != null) {
              flag = this.dmgPack.causeDamage((uf)this.shootingEntity, (of)bullet.g, (float)this.damage, (float)this.iceDamage, dmg);
            } else {
              if (this.damage > 0.0D) {
                flag = bullet.g.a(dmg, (float)this.damage);
                bullet.g.af = 0;
              } 
              if (this.iceDamage > 0.0D) {
                flag = (bullet.g.a((nb)new nc("ice_damage", this.shootingEntity), (float)this.iceDamage) || flag);
                bullet.g.af = 0;
              } 
            }  
          if (flag) {
            if (bullet.g instanceof of) {
              of living = (of)bullet.g;
              if (!this.q.I && !this.penetrate)
                living.m(living.aU() + 1); 
              if (this.knockbackStrength > 0.0F && !this.noeff) {
                float f3 = ls.a(this.x * this.x + this.z * this.z);
                if (f3 > 0.0F)
                  bullet.g.g(this.x * this.knockbackStrength * 0.6000000238418579D / f3, 0.1D, this.z * this.knockbackStrength * 0.6000000238418579D / f3); 
              } 
            } 
            a(this.hitSound, 1.0F, 1.2F / (this.ab.nextFloat() * 0.2F + 0.9F));
            if (!this.penetrate)
              x(); 
          } else {
            this.x *= -0.10000000149011612D;
            if (this.gravity)
              this.y *= -0.10000000149011612D; 
            this.z *= -0.10000000149011612D;
            this.A += 180.0F;
            this.C += 180.0F;
            this.ticksInAir = this.penetrate ? 5 : 0;
          } 
        } else {
          this.xTile = bullet.b;
          this.yTile = bullet.c;
          this.zTile = bullet.d;
          this.inTile = this.q.a(this.xTile, this.yTile, this.zTile);
          this.inData = this.q.h(this.xTile, this.yTile, this.zTile);
          this.x = (float)(bullet.f.c - this.u);
          if (this.gravity)
            this.y = (float)(bullet.f.d - this.v); 
          this.z = (float)(bullet.f.e - this.w);
          float f = ls.a(this.x * this.x + this.y * this.y + this.z * this.z);
          this.u -= this.x / f * 0.05000000074505806D;
          if (this.gravity)
            this.v -= this.y / f * 0.05000000074505806D; 
          this.w -= this.z / f * 0.05000000074505806D;
          a(this.hitSound, 1.0F, 1.2F / (this.ab.nextFloat() * 0.2F + 0.9F));
          this.inGround = true;
          if (this.inTile != 0)
            aqz.s[this.inTile].a(this.q, this.xTile, this.yTile, this.zTile, this); 
        }  
      this.u += this.x;
      this.v += this.y;
      this.w += this.z;
      float f2 = ls.a(this.x * this.x + this.z * this.z);
      this.A = (float)(Math.atan2(this.x, this.z) * 180.0D / Math.PI);
      this.B = (float)(Math.atan2(this.y, f2) * 180.0D / Math.PI);
      while (this.B - this.D < -180.0F)
        this.D -= 360.0F; 
      while (this.B - this.D >= 180.0F)
        this.D += 360.0F; 
      while (this.A - this.C < -180.0F)
        this.C -= 360.0F; 
      while (this.A - this.C >= 180.0F)
        this.C += 360.0F; 
      this.B = this.D + (this.B - this.D) * 0.2F;
      this.A = this.C + (this.A - this.C) * 0.2F;
      float f4 = 0.99F;
      float f1 = 0.05F;
      if (H()) {
        for (int j1 = 0; j1 < 4; j1++) {
          float f3 = 0.25F;
          this.q.a("bubble", this.u - this.x * f3, this.v - this.y * f3, this.w - this.z * f3, this.x, this.y, this.z);
        } 
        f4 = 0.8F;
      } 
      this.x *= f4;
      if (this.gravity)
        this.y *= f4; 
      this.z *= f4;
      if (this.gravity)
        this.y -= f1; 
      b(this.u, this.v, this.w);
      D();
    } 
  }
  
  public void setKnockbackStrength(float par1) {
    this.knockbackStrength = par1;
  }
  
  protected void a() {}
  
  protected void a(by nbt) {
    this.xTile = nbt.d("xTile");
    this.yTile = nbt.d("yTile");
    this.zTile = nbt.d("zTile");
    this.inTile = nbt.c("inTile") & 0xFF;
    this.inData = nbt.c("inData") & 0xFF;
    this.inGround = (nbt.c("inGround") == 1);
    if (nbt.b("damage"))
      this.damage = nbt.h("damage"); 
  }
  
  protected void b(by nbt) {
    nbt.a("xTile", (short)this.xTile);
    nbt.a("yTile", (short)this.yTile);
    nbt.a("zTile", (short)this.zTile);
    nbt.a("inTile", (byte)this.inTile);
    nbt.a("inData", (byte)this.inData);
    nbt.a("inGround", (byte)(this.inGround ? 1 : 0));
    nbt.a("damage", this.damage);
  }
  
  public void c(double x, double y, double z, float speed, float flu) {
    float vec_len = ls.a(x * x + y * y + z * z);
    x /= vec_len;
    y /= vec_len;
    z /= vec_len;
    x += this.ab.nextGaussian() * (this.ab.nextBoolean() ? -1 : true) * 0.007499999832361937D * flu;
    y += this.ab.nextGaussian() * (this.ab.nextBoolean() ? -1 : true) * 0.007499999832361937D * flu;
    z += this.ab.nextGaussian() * (this.ab.nextBoolean() ? -1 : true) * 0.007499999832361937D * flu;
    x *= speed;
    y *= speed;
    z *= speed;
    this.x = x;
    this.y = y;
    this.z = z;
    float level_vec_len = ls.a(x * x + z * z);
    this.C = this.A = (float)(Math.atan2(x, z) * 180.0D / Math.PI);
    this.D = this.B = (float)(Math.atan2(y, level_vec_len) * 180.0D / Math.PI);
    this.ticksInGround = 0;
  }
  
  public void setAmmo(BasicAmmo ammo) {
    this.ammo = ammo;
  }
  
  public void setGravity(boolean gravity) {
    this.gravity = gravity;
  }
  
  public void setMaxRange(double maxRange) {
    this.maxRange = maxRange * maxRange;
  }
  
  public void setDamagePacket(DamagePacket packet) {
    this.dmgPack = packet;
  }
  
  public boolean e_() {
    return false;
  }
  
  public boolean aq() {
    return false;
  }
  
  @SideOnly(Side.CLIENT)
  public void a(double x, double y, double z, float yaw, float pitch, int par9) {
    b(x, y, z);
    b(yaw, pitch);
  }
  
  @SideOnly(Side.CLIENT)
  public void h(double x, double y, double z) {
    this.x = x;
    this.y = y;
    this.z = z;
    if (this.D == 0.0F && this.C == 0.0F) {
      float level_vec_len = ls.a(x * x + z * z);
      this.C = this.A = (float)(Math.atan2(x, z) * 180.0D / Math.PI);
      this.D = this.B = (float)(Math.atan2(y, level_vec_len) * 180.0D / Math.PI);
      this.D = this.B;
      this.C = this.A;
      b(this.u, this.v, this.w, this.A, this.B);
      this.ticksInGround = 0;
    } 
  }
  
  @SideOnly(Side.CLIENT)
  public float S() {
    return 0.0F;
  }
}
